## mllex-polyml 0.0~git20210410.85768e9

=== Makefile ===
## Copyright (C) 2020 Takayuki Goto

POLYML       := poly
POLYMLC      := polyc
POLYMLFLAGS  := -q --error-exit

PDFLATEX     := pdflatex
DIFF         := diff

PREFIX       := /usr/local/polyml
BINDIR       := bin
DOCDIR       := doc/mllex-polyml

MLLEX_POLYML := mllex-polyml

DOCS         := mllex-polyml.pdf

SRCS         := $(wildcard *.sml)


all: mllex-polyml


.PHONY: mllex-polyml
mllex-polyml: mllex-polyml-nodocs docs


.PHONY: mllex-polyml-nodocs
mllex-polyml-nodocs: $(BINDIR)/$(MLLEX_POLYML)


$(BINDIR)/$(MLLEX_POLYML): $(MLLEX_POLYML).o
	@echo "  [POLYMLC] $@"
	@$(POLYMLC) -o $@ $^


$(MLLEX_POLYML).o: $(SRCS)
	@echo "  [POLYML] $@"
	@echo "" | $(POLYML) $(POLYMLFLAGS) \
		--eval 'PolyML.make (OS.FileSys.getDir())' \
		--eval 'PolyML.export ("$@", Main.main)'


lexgen.pdf: lexgen.tex
	-$(RM) lexgen.aux lexgen.log lexgen.toc lexgen.pdf
	$(PDFLATEX) lexgen.tex
	$(PDFLATEX) lexgen.tex
	$(PDFLATEX) lexgen.tex


$(DOCS): lexgen.pdf
	cp lexgen.pdf $(DOCS)


.PHONY: docs
docs: $(DOCS)


.PHONY: test
test: mllex-polyml-nodocs
	$(BINDIR)/$(MLLEX_POLYML) ml.lex
	$(DIFF) ml.lex.sml ml.lex.sml.exp
	$(RM)   ml.lex.sml


.PHONY: install-nodocs
install-nodocs: mllex-polyml-nodocs
	install -D -m 0755 -t $(PREFIX)/$(BINDIR) $(BINDIR)/$(MLLEX_POLYML)


.PHONY: install
install: install-nodocs docs
	install -D -m 0444 -t $(PREFIX)/$(DOCDIR) $(DOCS)


.PHONY: clean
clean:
	-$(RM) $(BINDIR)/$(MLLEX_POLYML) $(MLLEX_POLYML).o
	-$(RM) $(DOCS)
	-$(RM) lexgen.aux lexgen.log lexgen.toc lexgen.pdf

=== debian/changelog ===
mllex-polyml (0.0~git20210410.85768e9-1) unstable; urgency=medium

  * Initial release (Closes: #1003358)

 -- Ryan Kavanagh <rak@debian.org>  Mon, 19 May 2025 11:16:24 -0400

=== debian/control ===
Source: mllex-polyml
Section: devel
Priority: optional
Maintainer: Ryan Kavanagh <rak@debian.org>
Build-Depends:
 chrpath,
 debhelper-compat (= 13),
 libpolyml-dev,
 polyml,
 texlive-latex-base,
Standards-Version: 4.7.2
Homepage: https://github.com/eldesh/mllex-polyml
Vcs-Browser: https://salsa.debian.org/debian/mllex-polyml
Vcs-Git: https://salsa.debian.org/debian/mllex-polyml.git
Rules-Requires-Root: no

Package: mllex-polyml
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: lexical analyzer generator for Standard ML
 An implementation of mllex ported from mlton to poly/ml.
 .
 Lex allows the programmer to make the language description explicit, and to
 concentrate on what to do with the recognized words, not how to recognize the
 words. It saves programmer time and increases program maintainability.
 Unfortunately, Lex is targeted only C. It also places artificial limits on the
 size of strings that can be recognized.
 .
 ML-Lex is a variant of Lex for the ML programming language. ML-Lex has a
 syntax similar to Lex, and produces an ML program instead of a C program.
 ML-Lex produces a program that runs very efficiently. Typically the program
 will be as fast or even faster than a hand-coded lexer implemented in Standard
 ML.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_install:
	chrpath -d bin/mllex-polyml
	$(MAKE) install-nodocs PREFIX=$(CURDIR)/debian/mllex-polyml/usr

override_dh_strip:
	# It does not make sense to generate debugging symbols for an SML
	# program: any stack trace you get will be useless
	dh_strip --no-automatic-dbgsym

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# GitHub hosted projects
opts="mode=git, gitmode=full, pgpmode=none" \
   https://github.com/eldesh/mllex-polyml \
   HEAD
